maint.mk: provide "make upload" to ease uploading
[gnulib.git] / top / maint.mk
1 # -*-Makefile-*-
2 # This Makefile fragment tries to be general-purpose enough to be
3 # used by many projects via the gnulib maintainer-makefile module.
4
5 ## Copyright (C) 2001-2012 Free Software Foundation, Inc.
6 ##
7 ## This program is free software: you can redistribute it and/or modify
8 ## it under the terms of the GNU General Public License as published by
9 ## the Free Software Foundation, either version 3 of the License, or
10 ## (at your option) any later version.
11 ##
12 ## This program is distributed in the hope that it will be useful,
13 ## but WITHOUT ANY WARRANTY; without even the implied warranty of
14 ## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
15 ## GNU General Public License for more details.
16 ##
17 ## You should have received a copy of the GNU General Public License
18 ## along with this program.  If not, see <http://www.gnu.org/licenses/>.
19
20 # This is reported not to work with make-3.79.1
21 # ME := $(word $(words $(MAKEFILE_LIST)),$(MAKEFILE_LIST))
22 ME := maint.mk
23
24 # Diagnostic for continued use of deprecated variable.
25 # Remove in 2013
26 ifneq ($(build_aux),)
27  $(error "$(ME): \
28 set $$(_build-aux) relative to $$(srcdir) instead of $$(build_aux)")
29 endif
30
31 # Helper variables.
32 _empty =
33 _sp = $(_empty) $(_empty)
34
35 # member-check VARIABLE,VALID-VALUES
36 # ----------------------------------
37 # Check that $(VARIABLE) is in the space-separated list of VALID-VALUES, and
38 # return it.  Die otherwise.
39 member-check =                                                  \
40   $(if $($(1)),                                                 \
41     $(if $(findstring $(_sp),$($(1))),                          \
42         $(error invalid $(1): '$($(1))', expected $(2)),        \
43         $(or $(findstring $(_sp)$($(1))$(_sp),$(_sp)$(2)(_sp)), \
44           $(error invalid $(1): '$($(1))', expected $(2)))),    \
45     $(error $(1) undefined))
46
47 # Do not save the original name or timestamp in the .tar.gz file.
48 # Use --rsyncable if available.
49 gzip_rsyncable := \
50   $(shell gzip --help 2>/dev/null|grep rsyncable >/dev/null \
51     && printf %s --rsyncable)
52 GZIP_ENV = '--no-name --best $(gzip_rsyncable)'
53
54 GIT = git
55 VC = $(GIT)
56
57 VC_LIST = $(srcdir)/$(_build-aux)/vc-list-files -C $(srcdir)
58
59 # You can override this variable in cfg.mk to set your own regexp
60 # matching files to ignore.
61 VC_LIST_ALWAYS_EXCLUDE_REGEX ?= ^$$
62
63 # This is to preprocess robustly the output of $(VC_LIST), so that even
64 # when $(srcdir) is a pathological name like "....", the leading sed command
65 # removes only the intended prefix.
66 _dot_escaped_srcdir = $(subst .,\.,$(srcdir))
67
68 # Post-process $(VC_LIST) output, prepending $(srcdir)/, but only
69 # when $(srcdir) is not ".".
70 ifeq ($(srcdir),.)
71 _prepend_srcdir_prefix =
72 else
73 _prepend_srcdir_prefix = | sed 's|^|$(srcdir)/|'
74 endif
75
76 # In order to be able to consistently filter "."-relative names,
77 # (i.e., with no $(srcdir) prefix), this definition is careful to
78 # remove any $(srcdir) prefix, and to restore what it removes.
79 _sc_excl = \
80   $(or $(exclude_file_name_regexp--$@),^$$)
81 VC_LIST_EXCEPT = \
82   $(VC_LIST) | sed 's|^$(_dot_escaped_srcdir)/||' \
83         | if test -f $(srcdir)/.x-$@; then grep -vEf $(srcdir)/.x-$@; \
84           else grep -Ev -e "$${VC_LIST_EXCEPT_DEFAULT-ChangeLog}"; fi \
85         | grep -Ev -e '($(VC_LIST_ALWAYS_EXCLUDE_REGEX)|$(_sc_excl))' \
86         $(_prepend_srcdir_prefix)
87
88 ifeq ($(origin prev_version_file), undefined)
89   prev_version_file = $(srcdir)/.prev-version
90 endif
91
92 PREV_VERSION := $(shell cat $(prev_version_file) 2>/dev/null)
93 VERSION_REGEXP = $(subst .,\.,$(VERSION))
94 PREV_VERSION_REGEXP = $(subst .,\.,$(PREV_VERSION))
95
96 ifeq ($(VC),$(GIT))
97 this-vc-tag = v$(VERSION)
98 this-vc-tag-regexp = v$(VERSION_REGEXP)
99 else
100 tag-package = $(shell echo "$(PACKAGE)" | tr '[:lower:]' '[:upper:]')
101 tag-this-version = $(subst .,_,$(VERSION))
102 this-vc-tag = $(tag-package)-$(tag-this-version)
103 this-vc-tag-regexp = $(this-vc-tag)
104 endif
105 my_distdir = $(PACKAGE)-$(VERSION)
106
107 # Old releases are stored here.
108 release_archive_dir ?= ../release
109
110 # If RELEASE_TYPE is undefined, but RELEASE is, use its second word.
111 # But overwrite VERSION.
112 ifdef RELEASE
113   VERSION := $(word 1, $(RELEASE))
114   RELEASE_TYPE ?= $(word 2, $(RELEASE))
115 endif
116
117 # Validate and return $(RELEASE_TYPE), or die.
118 RELEASE_TYPES = alpha beta stable
119 release-type = $(call member-check,RELEASE_TYPE,$(RELEASE_TYPES))
120
121 # Override gnu_rel_host and url_dir_list in cfg.mk if these are not right.
122 # Use alpha.gnu.org for alpha and beta releases.
123 # Use ftp.gnu.org for stable releases.
124 gnu_ftp_host-alpha = alpha.gnu.org
125 gnu_ftp_host-beta = alpha.gnu.org
126 gnu_ftp_host-stable = ftp.gnu.org
127 gnu_rel_host ?= $(gnu_ftp_host-$(release-type))
128
129 ifeq ($(gnu_rel_host),ftp.gnu.org)
130 url_dir_list ?= http://ftpmirror.gnu.org/$(PACKAGE)
131 else
132 url_dir_list ?= ftp://$(gnu_rel_host)/gnu/$(PACKAGE)
133 endif
134
135 # Override this in cfg.mk if you are using a different format in your
136 # NEWS file.
137 today = $(shell date +%Y-%m-%d)
138
139 # Select which lines of NEWS are searched for $(news-check-regexp).
140 # This is a sed line number spec.  The default says that we search
141 # lines 1..10 of NEWS for $(news-check-regexp).
142 # If you want to search only line 3 or only lines 20-22, use "3" or "20,22".
143 news-check-lines-spec ?= 1,10
144 news-check-regexp ?= '^\*.* $(VERSION_REGEXP) \($(today)\)'
145
146 # Prevent programs like 'sort' from considering distinct strings to be equal.
147 # Doing it here saves us from having to set LC_ALL elsewhere in this file.
148 export LC_ALL = C
149
150 ## --------------- ##
151 ## Sanity checks.  ##
152 ## --------------- ##
153
154 _cfg_mk := $(shell test -f $(srcdir)/cfg.mk && echo '$(srcdir)/cfg.mk')
155
156 # Collect the names of rules starting with 'sc_'.
157 syntax-check-rules := $(sort $(shell sed -n 's/^\(sc_[a-zA-Z0-9_-]*\):.*/\1/p' \
158                         $(srcdir)/$(ME) $(_cfg_mk)))
159 .PHONY: $(syntax-check-rules)
160
161 ifeq ($(shell $(VC_LIST) >/dev/null 2>&1; echo $$?),0)
162 local-checks-available += $(syntax-check-rules)
163 else
164 local-checks-available += no-vc-detected
165 no-vc-detected:
166         @echo "No version control files detected; skipping syntax check"
167 endif
168 .PHONY: $(local-checks-available)
169
170 # Arrange to print the name of each syntax-checking rule just before running it.
171 $(syntax-check-rules): %: %.m
172 sc_m_rules_ = $(patsubst %, %.m, $(syntax-check-rules))
173 .PHONY: $(sc_m_rules_)
174 $(sc_m_rules_):
175         @echo $(patsubst sc_%.m, %, $@)
176         @date +%s.%N > .sc-start-$(basename $@)
177
178 # Compute and print the elapsed time for each syntax-check rule.
179 sc_z_rules_ = $(patsubst %, %.z, $(syntax-check-rules))
180 .PHONY: $(sc_z_rules_)
181 $(sc_z_rules_): %.z: %
182         @end=$$(date +%s.%N);                                           \
183         start=$$(cat .sc-start-$*);                                     \
184         rm -f .sc-start-$*;                                             \
185         awk -v s=$$start -v e=$$end                                     \
186           'END {printf "%.2f $(patsubst sc_%,%,$*)\n", e - s}' < /dev/null
187
188 # The patsubst here is to replace each sc_% rule with its sc_%.z wrapper
189 # that computes and prints elapsed time.
190 local-check :=                                                          \
191   $(patsubst sc_%, sc_%.z,                                              \
192     $(filter-out $(local-checks-to-skip), $(local-checks-available)))
193
194 syntax-check: $(local-check)
195
196 # _sc_search_regexp
197 #
198 # This macro searches for a given construct in the selected files and
199 # then takes some action.
200 #
201 # Parameters (shell variables):
202 #
203 #  prohibit | require
204 #
205 #     Regular expression (ERE) denoting either a forbidden construct
206 #     or a required construct.  Those arguments are exclusive.
207 #
208 #  exclude
209 #
210 #     Regular expression (ERE) denoting lines to ignore that matched
211 #     a prohibit construct.  For example, this can be used to exclude
212 #     comments that mention why the nearby code uses an alternative
213 #     construct instead of the simpler prohibited construct.
214 #
215 #  in_vc_files | in_files
216 #
217 #     grep-E-style regexp selecting the files to check.  For in_vc_files,
218 #     the regexp is used to select matching files from the list of all
219 #     version-controlled files; for in_files, it's from the names printed
220 #     by "find $(srcdir)".  When neither is specified, use all files that
221 #     are under version control.
222 #
223 #  containing | non_containing
224 #
225 #     Select the files (non) containing strings matching this regexp.
226 #     If both arguments are specified then CONTAINING takes
227 #     precedence.
228 #
229 #  with_grep_options
230 #
231 #     Extra options for grep.
232 #
233 #  ignore_case
234 #
235 #     Ignore case.
236 #
237 #  halt
238 #
239 #     Message to display before to halting execution.
240 #
241 # Finally, you may exempt files based on an ERE matching file names.
242 # For example, to exempt from the sc_space_tab check all files with the
243 # .diff suffix, set this Make variable:
244 #
245 # exclude_file_name_regexp--sc_space_tab = \.diff$
246 #
247 # Note that while this functionality is mostly inherited via VC_LIST_EXCEPT,
248 # when filtering by name via in_files, we explicitly filter out matching
249 # names here as well.
250
251 # Initialize each, so that envvar settings cannot interfere.
252 export require =
253 export prohibit =
254 export exclude =
255 export in_vc_files =
256 export in_files =
257 export containing =
258 export non_containing =
259 export halt =
260 export with_grep_options =
261
262 # By default, _sc_search_regexp does not ignore case.
263 export ignore_case =
264 _ignore_case = $$(test -n "$$ignore_case" && printf %s -i || :)
265
266 define _sc_say_and_exit
267    dummy=; : so we do not need a semicolon before each use;             \
268    { printf '%s\n' "$(ME): $$msg" 1>&2; exit 1; };
269 endef
270
271 define _sc_search_regexp
272    dummy=; : so we do not need a semicolon before each use;             \
273                                                                         \
274    : Check arguments;                                                   \
275    test -n "$$prohibit" && test -n "$$require"                          \
276      && { msg='Cannot specify both prohibit and require'                \
277           $(_sc_say_and_exit) } || :;                                   \
278    test -z "$$prohibit" && test -z "$$require"                          \
279      && { msg='Should specify either prohibit or require'               \
280           $(_sc_say_and_exit) } || :;                                   \
281    test -z "$$prohibit" && test -n "$$exclude"                          \
282      && { msg='Use of exclude requires a prohibit pattern'              \
283           $(_sc_say_and_exit) } || :;                                   \
284    test -n "$$in_vc_files" && test -n "$$in_files"                      \
285      && { msg='Cannot specify both in_vc_files and in_files'            \
286           $(_sc_say_and_exit) } || :;                                   \
287    test "x$$halt" != x                                                  \
288      || { msg='halt not defined' $(_sc_say_and_exit) };                 \
289                                                                         \
290    : Filter by file name;                                               \
291    if test -n "$$in_files"; then                                        \
292      files=$$(find $(srcdir) | grep -E "$$in_files"                     \
293               | grep -Ev '$(_sc_excl)');                                \
294    else                                                                 \
295      files=$$($(VC_LIST_EXCEPT));                                       \
296      if test -n "$$in_vc_files"; then                                   \
297        files=$$(echo "$$files" | grep -E "$$in_vc_files");              \
298      fi;                                                                \
299    fi;                                                                  \
300                                                                         \
301    : Filter by content;                                                 \
302    test -n "$$files" && test -n "$$containing"                          \
303      && { files=$$(grep -l "$$containing" $$files); } || :;             \
304    test -n "$$files" && test -n "$$non_containing"                      \
305      && { files=$$(grep -vl "$$non_containing" $$files); } || :;        \
306                                                                         \
307    : Check for the construct;                                           \
308    if test -n "$$files"; then                                           \
309      if test -n "$$prohibit"; then                                      \
310        grep $$with_grep_options $(_ignore_case) -nE "$$prohibit" $$files \
311          | grep -vE "$${exclude:-^$$}"                                  \
312          && { msg="$$halt" $(_sc_say_and_exit) } || :;                  \
313      else                                                               \
314        grep $$with_grep_options $(_ignore_case) -LE "$$require" $$files \
315            | grep .                                                     \
316          && { msg="$$halt" $(_sc_say_and_exit) } || :;                  \
317      fi                                                                 \
318    else :;                                                              \
319    fi || :;
320 endef
321
322 sc_avoid_if_before_free:
323         @$(srcdir)/$(_build-aux)/useless-if-before-free                 \
324                 $(useless_free_options)                                 \
325             $$($(VC_LIST_EXCEPT) | grep -v useless-if-before-free) &&   \
326           { echo '$(ME): found useless "if" before "free" above' 1>&2;  \
327             exit 1; } || :
328
329 sc_cast_of_argument_to_free:
330         @prohibit='\<free *\( *\(' halt="don't cast free argument"      \
331           $(_sc_search_regexp)
332
333 sc_cast_of_x_alloc_return_value:
334         @prohibit='\*\) *x(m|c|re)alloc\>'                              \
335         halt="don't cast x*alloc return value"                          \
336           $(_sc_search_regexp)
337
338 sc_cast_of_alloca_return_value:
339         @prohibit='\*\) *alloca\>'                                      \
340         halt="don't cast alloca return value"                           \
341           $(_sc_search_regexp)
342
343 sc_space_tab:
344         @prohibit='[ ]  '                                               \
345         halt='found SPACE-TAB sequence; remove the SPACE'               \
346           $(_sc_search_regexp)
347
348 # Don't use *scanf or the old ato* functions in "real" code.
349 # They provide no error checking mechanism.
350 # Instead, use strto* functions.
351 sc_prohibit_atoi_atof:
352         @prohibit='\<([fs]?scanf|ato([filq]|ll)) *\('                           \
353         halt='do not use *scan''f, ato''f, ato''i, ato''l, ato''ll or ato''q'   \
354           $(_sc_search_regexp)
355
356 # Use STREQ rather than comparing strcmp == 0, or != 0.
357 sp_ = strcmp *\(.+\)
358 sc_prohibit_strcmp:
359         @prohibit='! *strcmp *\(|\<$(sp_) *[!=]=|[!=]= *$(sp_)'         \
360         exclude='# *define STRN?EQ\('                                   \
361         halt='replace strcmp calls above with STREQ/STRNEQ'             \
362           $(_sc_search_regexp)
363
364 # Really.  You don't want to use this function.
365 # It may fail to NUL-terminate the destination,
366 # and always NUL-pads out to the specified length.
367 sc_prohibit_strncpy:
368         @prohibit='\<strncpy *\('                                       \
369         halt='do not use strncpy, period'                               \
370           $(_sc_search_regexp)
371
372 # Pass EXIT_*, not number, to usage, exit, and error (when exiting)
373 # Convert all uses automatically, via these two commands:
374 # git grep -l '\<exit *(1)' \
375 #  | grep -vEf .x-sc_prohibit_magic_number_exit \
376 #  | xargs --no-run-if-empty \
377 #      perl -pi -e 's/(^|[^.])\b(exit ?)\(1\)/$1$2(EXIT_FAILURE)/'
378 # git grep -l '\<exit *(0)' \
379 #  | grep -vEf .x-sc_prohibit_magic_number_exit \
380 #  | xargs --no-run-if-empty \
381 #      perl -pi -e 's/(^|[^.])\b(exit ?)\(0\)/$1$2(EXIT_SUCCESS)/'
382 sc_prohibit_magic_number_exit:
383         @prohibit='(^|[^.])\<(usage|exit|error) ?\(-?[0-9]+[,)]'        \
384         exclude='exit \(77\)|error ?\(((0|77),|[^,]*)'                  \
385         halt='use EXIT_* values rather than magic number'               \
386           $(_sc_search_regexp)
387
388 # Using EXIT_SUCCESS as the first argument to error is misleading,
389 # since when that parameter is 0, error does not exit.  Use '0' instead.
390 sc_error_exit_success:
391         @prohibit='error *\(EXIT_SUCCESS,'                              \
392         in_vc_files='\.[chly]$$'                                        \
393         halt='found error (EXIT_SUCCESS'                                \
394          $(_sc_search_regexp)
395
396 # "FATAL:" should be fully upper-cased in error messages
397 # "WARNING:" should be fully upper-cased, or fully lower-cased
398 sc_error_message_warn_fatal:
399         @grep -nEA2 '[^rp]error *\(' $$($(VC_LIST_EXCEPT))              \
400             | grep -E '"Warning|"Fatal|"fatal' &&                       \
401           { echo '$(ME): use FATAL, WARNING or warning' 1>&2;           \
402             exit 1; } || :
403
404 # Error messages should not start with a capital letter
405 sc_error_message_uppercase:
406         @grep -nEA2 '[^rp]error *\(' $$($(VC_LIST_EXCEPT))              \
407             | grep -E '"[A-Z]'                                          \
408             | grep -vE '"FATAL|"WARNING|"Java|"C#|PRIuMAX' &&           \
409           { echo '$(ME): found capitalized error message' 1>&2;         \
410             exit 1; } || :
411
412 # Error messages should not end with a period
413 sc_error_message_period:
414         @grep -nEA2 '[^rp]error *\(' $$($(VC_LIST_EXCEPT))              \
415             | grep -E '[^."]\."' &&                                     \
416           { echo '$(ME): found error message ending in period' 1>&2;    \
417             exit 1; } || :
418
419 sc_file_system:
420         @prohibit=file''system                                          \
421         ignore_case=1                                                   \
422         halt='found use of "file''system"; spell it "file system"'      \
423           $(_sc_search_regexp)
424
425 # Don't use cpp tests of this symbol.  All code assumes config.h is included.
426 sc_prohibit_have_config_h:
427         @prohibit='^# *if.*HAVE''_CONFIG_H'                             \
428         halt='found use of HAVE''_CONFIG_H; remove'                     \
429           $(_sc_search_regexp)
430
431 # Nearly all .c files must include <config.h>.  However, we also permit this
432 # via inclusion of a package-specific header, if cfg.mk specified one.
433 # config_h_header must be suitable for grep -E.
434 config_h_header ?= <config\.h>
435 sc_require_config_h:
436         @require='^# *include $(config_h_header)'                       \
437         in_vc_files='\.c$$'                                             \
438         halt='the above files do not include <config.h>'                \
439           $(_sc_search_regexp)
440
441 # You must include <config.h> before including any other header file.
442 # This can possibly be via a package-specific header, if given by cfg.mk.
443 sc_require_config_h_first:
444         @if $(VC_LIST_EXCEPT) | grep -l '\.c$$' > /dev/null; then       \
445           fail=0;                                                       \
446           for i in $$($(VC_LIST_EXCEPT) | grep '\.c$$'); do             \
447             grep '^# *include\>' $$i | sed 1q                           \
448                 | grep -E '^# *include $(config_h_header)' > /dev/null  \
449               || { echo $$i; fail=1; };                                 \
450           done;                                                         \
451           test $$fail = 1 &&                                            \
452             { echo '$(ME): the above files include some other header'   \
453                 'before <config.h>' 1>&2; exit 1; } || :;               \
454         else :;                                                         \
455         fi
456
457 sc_prohibit_HAVE_MBRTOWC:
458         @prohibit='\bHAVE_MBRTOWC\b'                                    \
459         halt="do not use $$prohibit; it is always defined"              \
460           $(_sc_search_regexp)
461
462 # To use this "command" macro, you must first define two shell variables:
463 # h: the header name, with no enclosing <> or ""
464 # re: a regular expression that matches IFF something provided by $h is used.
465 define _sc_header_without_use
466   dummy=; : so we do not need a semicolon before each use;              \
467   h_esc=`echo '[<"]'"$$h"'[">]'|sed 's/\./\\\\./g'`;                    \
468   if $(VC_LIST_EXCEPT) | grep -l '\.c$$' > /dev/null; then              \
469     files=$$(grep -l '^# *include '"$$h_esc"                            \
470              $$($(VC_LIST_EXCEPT) | grep '\.c$$')) &&                   \
471     grep -LE "$$re" $$files | grep . &&                                 \
472       { echo "$(ME): the above files include $$h but don't use it"      \
473         1>&2; exit 1; } || :;                                           \
474   else :;                                                               \
475   fi
476 endef
477
478 # Prohibit the inclusion of assert.h without an actual use of assert.
479 sc_prohibit_assert_without_use:
480         @h='assert.h' re='\<assert *\(' $(_sc_header_without_use)
481
482 # Prohibit the inclusion of close-stream.h without an actual use.
483 sc_prohibit_close_stream_without_use:
484         @h='close-stream.h' re='\<close_stream *\(' $(_sc_header_without_use)
485
486 # Prohibit the inclusion of getopt.h without an actual use.
487 sc_prohibit_getopt_without_use:
488         @h='getopt.h' re='\<getopt(_long)? *\(' $(_sc_header_without_use)
489
490 # Don't include quotearg.h unless you use one of its functions.
491 sc_prohibit_quotearg_without_use:
492         @h='quotearg.h' re='\<quotearg(_[^ ]+)? *\(' $(_sc_header_without_use)
493
494 # Don't include quote.h unless you use one of its functions.
495 sc_prohibit_quote_without_use:
496         @h='quote.h' re='\<quote((_n)? *\(|_quoting_options\>)' \
497           $(_sc_header_without_use)
498
499 # Don't include this header unless you use one of its functions.
500 sc_prohibit_long_options_without_use:
501         @h='long-options.h' re='\<parse_long_options *\(' \
502           $(_sc_header_without_use)
503
504 # Don't include this header unless you use one of its functions.
505 sc_prohibit_inttostr_without_use:
506         @h='inttostr.h' re='\<(off|[iu]max|uint)tostr *\(' \
507           $(_sc_header_without_use)
508
509 # Don't include this header unless you use one of its functions.
510 sc_prohibit_ignore_value_without_use:
511         @h='ignore-value.h' re='\<ignore_(value|ptr) *\(' \
512           $(_sc_header_without_use)
513
514 # Don't include this header unless you use one of its functions.
515 sc_prohibit_error_without_use:
516         @h='error.h' \
517         re='\<error(_at_line|_print_progname|_one_per_line|_message_count)? *\('\
518           $(_sc_header_without_use)
519
520 # Don't include xalloc.h unless you use one of its functions.
521 # Consider these symbols:
522 # perl -lne '/^# *define (\w+)\(/ and print $1' lib/xalloc.h|grep -v '^__';
523 # perl -lne '/^(?:extern )?(?:void|char) \*?(\w+) *\(/ and print $1' lib/xalloc.h
524 # Divide into two sets on case, and filter each through this:
525 # | sort | perl -MRegexp::Assemble -le \
526 #  'print Regexp::Assemble->new(file => "/dev/stdin")->as_string'|sed 's/\?://g'
527 # Note this was produced by the above:
528 # _xa1 = \
529 #x(((2n?)?re|c(har)?|n(re|m)|z)alloc|alloc_(oversized|die)|m(alloc|emdup)|strdup)
530 # But we can do better, in at least two ways:
531 # 1) take advantage of two "dup"-suffixed strings:
532 # x(((2n?)?re|c(har)?|n(re|m)|[mz])alloc|alloc_(oversized|die)|(mem|str)dup)
533 # 2) notice that "c(har)?|[mz]" is equivalent to the shorter and more readable
534 # "char|[cmz]"
535 # x(((2n?)?re|char|n(re|m)|[cmz])alloc|alloc_(oversized|die)|(mem|str)dup)
536 _xa1 = x(((2n?)?re|char|n(re|m)|[cmz])alloc|alloc_(oversized|die)|(mem|str)dup)
537 _xa2 = X([CZ]|N?M)ALLOC
538 sc_prohibit_xalloc_without_use:
539         @h='xalloc.h' \
540         re='\<($(_xa1)|$(_xa2)) *\('\
541           $(_sc_header_without_use)
542
543 # Extract function names:
544 # perl -lne '/^(?:extern )?(?:void|char) \*?(\w+) *\(/ and print $1' lib/hash.h
545 _hash_re = \
546 clear|delete|free|get_(first|next)|insert|lookup|print_statistics|reset_tuning
547 _hash_fn = \<($(_hash_re)) *\(
548 _hash_struct = (struct )?\<[Hh]ash_(table|tuning)\>
549 sc_prohibit_hash_without_use:
550         @h='hash.h' \
551         re='$(_hash_fn)|$(_hash_struct)'\
552           $(_sc_header_without_use)
553
554 sc_prohibit_cloexec_without_use:
555         @h='cloexec.h' re='\<(set_cloexec_flag|dup_cloexec) *\(' \
556           $(_sc_header_without_use)
557
558 sc_prohibit_posixver_without_use:
559         @h='posixver.h' re='\<posix2_version *\(' $(_sc_header_without_use)
560
561 sc_prohibit_same_without_use:
562         @h='same.h' re='\<same_name *\(' $(_sc_header_without_use)
563
564 sc_prohibit_hash_pjw_without_use:
565         @h='hash-pjw.h' \
566         re='\<hash_pjw\>' \
567           $(_sc_header_without_use)
568
569 sc_prohibit_safe_read_without_use:
570         @h='safe-read.h' re='(\<SAFE_READ_ERROR\>|\<safe_read *\()' \
571           $(_sc_header_without_use)
572
573 sc_prohibit_argmatch_without_use:
574         @h='argmatch.h' \
575         re='(\<(ARRAY_CARDINALITY|X?ARGMATCH(|_TO_ARGUMENT|_VERIFY))\>|\<(invalid_arg|argmatch(_exit_fn|_(in)?valid)?) *\()' \
576           $(_sc_header_without_use)
577
578 sc_prohibit_canonicalize_without_use:
579         @h='canonicalize.h' \
580         re='CAN_(EXISTING|ALL_BUT_LAST|MISSING)|canonicalize_(mode_t|filename_mode|file_name)' \
581           $(_sc_header_without_use)
582
583 sc_prohibit_root_dev_ino_without_use:
584         @h='root-dev-ino.h' \
585         re='(\<ROOT_DEV_INO_(CHECK|WARN)\>|\<get_root_dev_ino *\()' \
586           $(_sc_header_without_use)
587
588 sc_prohibit_openat_without_use:
589         @h='openat.h' \
590         re='\<(openat_(permissive|needs_fchdir|(save|restore)_fail)|l?(stat|ch(own|mod))at|(euid)?accessat)\>' \
591           $(_sc_header_without_use)
592
593 # Prohibit the inclusion of c-ctype.h without an actual use.
594 ctype_re = isalnum|isalpha|isascii|isblank|iscntrl|isdigit|isgraph|islower\
595 |isprint|ispunct|isspace|isupper|isxdigit|tolower|toupper
596 sc_prohibit_c_ctype_without_use:
597         @h='c-ctype.h' re='\<c_($(ctype_re)) *\(' \
598           $(_sc_header_without_use)
599
600 # The following list was generated by running:
601 # man signal.h|col -b|perl -ne '/bsd_signal.*;/.../sigwaitinfo.*;/ and print' \
602 #   | perl -lne '/^\s+(?:int|void).*?(\w+).*/ and print $1' | fmt
603 _sig_functions = \
604   bsd_signal kill killpg pthread_kill pthread_sigmask raise sigaction \
605   sigaddset sigaltstack sigdelset sigemptyset sigfillset sighold sigignore \
606   siginterrupt sigismember signal sigpause sigpending sigprocmask sigqueue \
607   sigrelse sigset sigsuspend sigtimedwait sigwait sigwaitinfo
608 _sig_function_re = $(subst $(_sp),|,$(strip $(_sig_functions)))
609 # The following were extracted from "man signal.h" manually.
610 _sig_types_and_consts =                                                 \
611   MINSIGSTKSZ SA_NOCLDSTOP SA_NOCLDWAIT SA_NODEFER SA_ONSTACK           \
612   SA_RESETHAND SA_RESTART SA_SIGINFO SIGEV_NONE SIGEV_SIGNAL            \
613   SIGEV_THREAD SIGSTKSZ SIG_BLOCK SIG_SETMASK SIG_UNBLOCK SS_DISABLE    \
614   SS_ONSTACK mcontext_t pid_t sig_atomic_t sigevent siginfo_t sigset_t  \
615   sigstack sigval stack_t ucontext_t
616 # generated via this:
617 # perl -lne '/^#ifdef (SIG\w+)/ and print $1' lib/sig2str.c|sort -u|fmt -70
618 _sig_names =                                                            \
619   SIGABRT SIGALRM SIGALRM1 SIGBUS SIGCANCEL SIGCHLD SIGCLD SIGCONT      \
620   SIGDANGER SIGDIL SIGEMT SIGFPE SIGFREEZE SIGGRANT SIGHUP SIGILL       \
621   SIGINFO SIGINT SIGIO SIGIOT SIGKAP SIGKILL SIGKILLTHR SIGLOST SIGLWP  \
622   SIGMIGRATE SIGMSG SIGPHONE SIGPIPE SIGPOLL SIGPRE SIGPROF SIGPWR      \
623   SIGQUIT SIGRETRACT SIGSAK SIGSEGV SIGSOUND SIGSTKFLT SIGSTOP SIGSYS   \
624   SIGTERM SIGTHAW SIGTRAP SIGTSTP SIGTTIN SIGTTOU SIGURG SIGUSR1        \
625   SIGUSR2 SIGVIRT SIGVTALRM SIGWAITING SIGWINCH SIGWIND SIGWINDOW       \
626   SIGXCPU SIGXFSZ
627 _sig_syms_re = $(subst $(_sp),|,$(strip $(_sig_names) $(_sig_types_and_consts)))
628
629 # Prohibit the inclusion of signal.h without an actual use.
630 sc_prohibit_signal_without_use:
631         @h='signal.h'                                                   \
632         re='\<($(_sig_function_re)) *\(|\<($(_sig_syms_re))\>'          \
633           $(_sc_header_without_use)
634
635 # Don't include stdio--.h unless you use one of its functions.
636 sc_prohibit_stdio--_without_use:
637         @h='stdio--.h' re='\<((f(re)?|p)open|tmpfile) *\('              \
638           $(_sc_header_without_use)
639
640 # Don't include stdio-safer.h unless you use one of its functions.
641 sc_prohibit_stdio-safer_without_use:
642         @h='stdio-safer.h' re='\<((f(re)?|p)open|tmpfile)_safer *\('    \
643           $(_sc_header_without_use)
644
645 # Prohibit the inclusion of strings.h without a sensible use.
646 # Using the likes of bcmp, bcopy, bzero, index or rindex is not sensible.
647 sc_prohibit_strings_without_use:
648         @h='strings.h'                                                  \
649         re='\<(strn?casecmp|ffs(ll)?)\>'                                \
650           $(_sc_header_without_use)
651
652 # Get the list of symbol names with this:
653 # perl -lne '/^# *define ([A-Z]\w+)\(/ and print $1' lib/intprops.h|fmt
654 _intprops_names =                                                       \
655   TYPE_IS_INTEGER TYPE_TWOS_COMPLEMENT TYPE_ONES_COMPLEMENT             \
656   TYPE_SIGNED_MAGNITUDE TYPE_SIGNED TYPE_MINIMUM TYPE_MAXIMUM           \
657   INT_BITS_STRLEN_BOUND INT_STRLEN_BOUND INT_BUFSIZE_BOUND              \
658   INT_ADD_RANGE_OVERFLOW INT_SUBTRACT_RANGE_OVERFLOW                    \
659   INT_NEGATE_RANGE_OVERFLOW INT_MULTIPLY_RANGE_OVERFLOW                 \
660   INT_DIVIDE_RANGE_OVERFLOW INT_REMAINDER_RANGE_OVERFLOW                \
661   INT_LEFT_SHIFT_RANGE_OVERFLOW INT_ADD_OVERFLOW INT_SUBTRACT_OVERFLOW  \
662   INT_NEGATE_OVERFLOW INT_MULTIPLY_OVERFLOW INT_DIVIDE_OVERFLOW         \
663   INT_REMAINDER_OVERFLOW INT_LEFT_SHIFT_OVERFLOW
664 _intprops_syms_re = $(subst $(_sp),|,$(strip $(_intprops_names)))
665 # Prohibit the inclusion of intprops.h without an actual use.
666 sc_prohibit_intprops_without_use:
667         @h='intprops.h'                                                 \
668         re='\<($(_intprops_syms_re)) *\('                               \
669           $(_sc_header_without_use)
670
671 _stddef_syms_re = NULL|offsetof|ptrdiff_t|size_t|wchar_t
672 # Prohibit the inclusion of stddef.h without an actual use.
673 sc_prohibit_stddef_without_use:
674         @h='stddef.h'                                                   \
675         re='\<($(_stddef_syms_re))\>'                                   \
676           $(_sc_header_without_use)
677
678 _de1 = dirfd|(close|(fd)?open|read|rewind|seek|tell)dir(64)?(_r)?
679 _de2 = (versionsort|struct dirent|getdirentries|alphasort|scandir(at)?)(64)?
680 _de3 = MAXNAMLEN|DIR|ino_t|d_ino|d_fileno|d_namlen
681 _dirent_syms_re = $(_de1)|$(_de2)|$(_de3)
682 # Prohibit the inclusion of dirent.h without an actual use.
683 sc_prohibit_dirent_without_use:
684         @h='dirent.h'                                                   \
685         re='\<($(_dirent_syms_re))\>'                                   \
686           $(_sc_header_without_use)
687
688 # Prohibit the inclusion of verify.h without an actual use.
689 sc_prohibit_verify_without_use:
690         @h='verify.h'                                                   \
691         re='\<(verify(true|expr)?|static_assert) *\('                   \
692           $(_sc_header_without_use)
693
694 # Don't include xfreopen.h unless you use one of its functions.
695 sc_prohibit_xfreopen_without_use:
696         @h='xfreopen.h' re='\<xfreopen *\(' $(_sc_header_without_use)
697
698 sc_obsolete_symbols:
699         @prohibit='\<(HAVE''_FCNTL_H|O''_NDELAY)\>'                     \
700         halt='do not use HAVE''_FCNTL_H or O'_NDELAY                    \
701           $(_sc_search_regexp)
702
703 # FIXME: warn about definitions of EXIT_FAILURE, EXIT_SUCCESS, STREQ
704
705 # Each nonempty ChangeLog line must start with a year number, or a TAB.
706 sc_changelog:
707         @prohibit='^[^12        ]'                                      \
708         in_vc_files='^ChangeLog$$'                                      \
709         halt='found unexpected prefix in a ChangeLog'                   \
710           $(_sc_search_regexp)
711
712 # Ensure that each .c file containing a "main" function also
713 # calls set_program_name.
714 sc_program_name:
715         @require='set_program_name *\(m?argv\[0\]\);'                   \
716         in_vc_files='\.c$$'                                             \
717         containing='\<main *('                                          \
718         halt='the above files do not call set_program_name'             \
719           $(_sc_search_regexp)
720
721 # Ensure that each .c file containing a "main" function also
722 # calls bindtextdomain.
723 sc_bindtextdomain:
724         @require='bindtextdomain *\('                                   \
725         in_vc_files='\.c$$'                                             \
726         containing='\<main *('                                          \
727         halt='the above files do not call bindtextdomain'               \
728           $(_sc_search_regexp)
729
730 # Require that the final line of each test-lib.sh-using test be this one:
731 # Exit $fail
732 # Note: this test requires GNU grep's --label= option.
733 Exit_witness_file ?= tests/test-lib.sh
734 Exit_base := $(notdir $(Exit_witness_file))
735 sc_require_test_exit_idiom:
736         @if test -f $(srcdir)/$(Exit_witness_file); then                \
737           die=0;                                                        \
738           for i in $$(grep -l -F 'srcdir/$(Exit_base)'                  \
739                 $$($(VC_LIST) tests)); do                               \
740             tail -n1 $$i | grep '^Exit .' > /dev/null                   \
741               && : || { die=1; echo $$i; }                              \
742           done;                                                         \
743           test $$die = 1 &&                                             \
744             { echo 1>&2 '$(ME): the final line in each of the above is not:'; \
745               echo 1>&2 'Exit something';                               \
746               exit 1; } || :;                                           \
747         fi
748
749 sc_trailing_blank:
750         @prohibit='[     ]$$'                                           \
751         halt='found trailing blank(s)'                                  \
752         exclude='^Binary file .* matches$$'                             \
753           $(_sc_search_regexp)
754
755 # Match lines like the following, but where there is only one space
756 # between the options and the description:
757 #   -D, --all-repeated[=delimit-method]  print all duplicate lines\n
758 longopt_re = --[a-z][0-9A-Za-z-]*(\[?=[0-9A-Za-z-]*\]?)?
759 sc_two_space_separator_in_usage:
760         @prohibit='^   *(-[A-Za-z],)? $(longopt_re) [^ ].*\\$$'         \
761         halt='help2man requires at least two spaces between an option and its description'\
762           $(_sc_search_regexp)
763
764 # A regexp matching function names like "error" that may be used
765 # to emit translatable messages.
766 _gl_translatable_diag_func_re ?= error
767
768 # Look for diagnostics that aren't marked for translation.
769 # This won't find any for which error's format string is on a separate line.
770 sc_unmarked_diagnostics:
771         @prohibit='\<$(_gl_translatable_diag_func_re) *\([^"]*"[^"]*[a-z]{3}' \
772         exclude='(_|ngettext ?)\('                                      \
773         halt='found unmarked diagnostic(s)'                             \
774           $(_sc_search_regexp)
775
776 # Avoid useless parentheses like those in this example:
777 # #if defined (SYMBOL) || defined (SYM2)
778 sc_useless_cpp_parens:
779         @prohibit='^# *if .*defined *\('                                \
780         halt='found useless parentheses in cpp directive'               \
781           $(_sc_search_regexp)
782
783 # List headers for which HAVE_HEADER_H is always true, assuming you are
784 # using the appropriate gnulib module.  CAUTION: for each "unnecessary"
785 # #if HAVE_HEADER_H that you remove, be sure that your project explicitly
786 # requires the gnulib module that guarantees the usability of that header.
787 gl_assured_headers_ = \
788   cd $(gnulib_dir)/lib && echo *.in.h|sed 's/\.in\.h//g'
789
790 # Convert the list of names to upper case, and replace each space with "|".
791 az_ = abcdefghijklmnopqrstuvwxyz
792 AZ_ = ABCDEFGHIJKLMNOPQRSTUVWXYZ
793 gl_header_upper_case_or_ =                                              \
794   $$($(gl_assured_headers_)                                             \
795     | tr $(az_)/.- $(AZ_)___                                            \
796     | tr -s ' ' '|'                                                     \
797     )
798 sc_prohibit_always_true_header_tests:
799         @or=$(gl_header_upper_case_or_);                                \
800         re="HAVE_($$or)_H";                                             \
801         prohibit='\<'"$$re"'\>'                                         \
802         halt=$$(printf '%s\n'                                           \
803         'do not test the above HAVE_<header>_H symbol(s);'              \
804         '  with the corresponding gnulib module, they are always true') \
805           $(_sc_search_regexp)
806
807 sc_prohibit_defined_have_decl_tests:
808         @prohibit='#[    ]*if(n?def|.*\<defined)\>[      (]+HAVE_DECL_' \
809         halt='HAVE_DECL macros are always defined'                      \
810           $(_sc_search_regexp)
811
812 # ==================================================================
813 gl_other_headers_ ?= \
814   intprops.h    \
815   openat.h      \
816   stat-macros.h
817
818 # Perl -lne code to extract "significant" cpp-defined symbols from a
819 # gnulib header file, eliminating a few common false-positives.
820 # The exempted names below are defined only conditionally in gnulib,
821 # and hence sometimes must/may be defined in application code.
822 gl_extract_significant_defines_ = \
823   /^\# *define ([^_ (][^ (]*)(\s*\(|\s+\w+)/\
824     && $$2 !~ /(?:rpl_|_used_without_)/\
825     && $$1 !~ /^(?:NSIG|ENODATA)$$/\
826     && $$1 !~ /^(?:SA_RESETHAND|SA_RESTART)$$/\
827     and print $$1
828
829 # Create a list of regular expressions matching the names
830 # of macros that are guaranteed to be defined by parts of gnulib.
831 define def_sym_regex
832         gen_h=$(gl_generated_headers_);                                 \
833         (cd $(gnulib_dir)/lib;                                          \
834           for f in *.in.h $(gl_other_headers_); do                      \
835             test -f $$f                                                 \
836               && perl -lne '$(gl_extract_significant_defines_)' $$f;    \
837           done;                                                         \
838         ) | sort -u                                                     \
839           | sed 's/^/^ *# *(define|undef)  */;s/$$/\\>/'
840 endef
841
842 # Don't define macros that we already get from gnulib header files.
843 sc_prohibit_always-defined_macros:
844         @if test -d $(gnulib_dir); then                                 \
845           case $$(echo all: | grep -l -f - Makefile) in Makefile);; *)  \
846             echo '$(ME): skipping $@: you lack GNU grep' 1>&2; exit 0;; \
847           esac;                                                         \
848           $(def_sym_regex) | grep -E -f - $$($(VC_LIST_EXCEPT))         \
849             && { echo '$(ME): define the above via some gnulib .h file' \
850                   1>&2;  exit 1; } || :;                                \
851         fi
852 # ==================================================================
853
854 # Prohibit checked in backup files.
855 sc_prohibit_backup_files:
856         @$(VC_LIST) | grep '~$$' &&                             \
857           { echo '$(ME): found version controlled backup file' 1>&2;    \
858             exit 1; } || :
859
860 # Require the latest GPL.
861 sc_GPL_version:
862         @prohibit='either ''version [^3]'                               \
863         halt='GPL vN, N!=3'                                             \
864           $(_sc_search_regexp)
865
866 # Require the latest GFDL.  Two regexp, since some .texi files end up
867 # line wrapping between 'Free Documentation License,' and 'Version'.
868 _GFDL_regexp = (Free ''Documentation.*Version 1\.[^3]|Version 1\.[^3] or any)
869 sc_GFDL_version:
870         @prohibit='$(_GFDL_regexp)'                                     \
871         halt='GFDL vN, N!=3'                                            \
872           $(_sc_search_regexp)
873
874 # Don't use Texinfo's @acronym{}.
875 # http://lists.gnu.org/archive/html/bug-gnulib/2010-03/msg00321.html
876 texinfo_suffix_re_ ?= \.(txi|texi(nfo)?)$$
877 sc_texinfo_acronym:
878         @prohibit='@acronym\{'                                          \
879         in_vc_files='$(texinfo_suffix_re_)'                             \
880         halt='found use of Texinfo @acronym{}'                          \
881           $(_sc_search_regexp)
882
883 cvs_keywords = \
884   Author|Date|Header|Id|Name|Locker|Log|RCSfile|Revision|Source|State
885
886 sc_prohibit_cvs_keyword:
887         @prohibit='\$$($(cvs_keywords))\$$'                             \
888         halt='do not use CVS keyword expansion'                         \
889           $(_sc_search_regexp)
890
891 # This Perl code is slightly obfuscated.  Not only is each "$" doubled
892 # because it's in a Makefile, but the $$c's are comments;  we cannot
893 # use "#" due to the way the script ends up concatenated onto one line.
894 # It would be much more concise, and would produce better output (including
895 # counts) if written as:
896 #   perl -ln -0777 -e '/\n(\n+)$/ and print "$ARGV: ".length $1' ...
897 # but that would be far less efficient, reading the entire contents
898 # of each file, rather than just the last two bytes of each.
899 # In addition, while the code below detects both blank lines and a missing
900 # newline at EOF, the above detects only the former.
901 #
902 # This is a perl script that is expected to be the single-quoted argument
903 # to a command-line "-le".  The remaining arguments are file names.
904 # Print the name of each file that does not end in exactly one newline byte.
905 # I.e., warn if there are blank lines (2 or more newlines), or if the
906 # last byte is not a newline.  However, currently we don't complain
907 # about any file that contains exactly one byte.
908 # Exit nonzero if at least one such file is found, otherwise, exit 0.
909 # Warn about, but otherwise ignore open failure.  Ignore seek/read failure.
910 #
911 # Use this if you want to remove trailing empty lines from selected files:
912 #   perl -pi -0777 -e 's/\n\n+$/\n/' files...
913 #
914 require_exactly_one_NL_at_EOF_ =                                        \
915   foreach my $$f (@ARGV)                                                \
916     {                                                                   \
917       open F, "<", $$f or (warn "failed to open $$f: $$!\n"), next;     \
918       my $$p = sysseek (F, -2, 2);                                      \
919       my $$c = "seek failure probably means file has < 2 bytes; ignore"; \
920       my $$last_two_bytes;                                              \
921       defined $$p and $$p = sysread F, $$last_two_bytes, 2;             \
922       close F;                                                          \
923       $$c = "ignore read failure";                                      \
924       $$p && ($$last_two_bytes eq "\n\n"                                \
925               || substr ($$last_two_bytes,1) ne "\n")                   \
926           and (print $$f), $$fail=1;                                    \
927     }                                                                   \
928   END { exit defined $$fail }
929 sc_prohibit_empty_lines_at_EOF:
930         @perl -le '$(require_exactly_one_NL_at_EOF_)' $$($(VC_LIST_EXCEPT)) \
931           || { echo '$(ME): empty line(s) or no newline at EOF'         \
932                 1>&2; exit 1; } || :
933
934 # Make sure we don't use st_blocks.  Use ST_NBLOCKS instead.
935 # This is a bit of a kludge, since it prevents use of the string
936 # even in comments, but for now it does the job with no false positives.
937 sc_prohibit_stat_st_blocks:
938         @prohibit='[.>]st_blocks'                                       \
939         halt='do not use st_blocks; use ST_NBLOCKS'                     \
940           $(_sc_search_regexp)
941
942 # Make sure we don't define any S_IS* macros in src/*.c files.
943 # They're already defined via gnulib's sys/stat.h replacement.
944 sc_prohibit_S_IS_definition:
945         @prohibit='^ *# *define  *S_IS'                                 \
946         halt='do not define S_IS* macros; include <sys/stat.h>'         \
947           $(_sc_search_regexp)
948
949 # Perl block to convert a match to FILE_NAME:LINENO:TEST,
950 # that is shared by two definitions below.
951 perl_filename_lineno_text_ =                                            \
952     -e '  {'                                                            \
953     -e '    $$n = ($$` =~ tr/\n/\n/ + 1);'                              \
954     -e '    ($$v = $$&) =~ s/\n/\\n/g;'                                 \
955     -e '    print "$$ARGV:$$n:$$v\n";'                                  \
956     -e '  }'
957
958 prohibit_doubled_word_RE_ ?= \
959   /\b(then?|[iao]n|i[fst]|but|f?or|at|and|[dt]o)\s+\1\b/gims
960 prohibit_doubled_word_ =                                                \
961     -e 'while ($(prohibit_doubled_word_RE_))'                           \
962     $(perl_filename_lineno_text_)
963
964 # Define this to a regular expression that matches
965 # any filename:dd:match lines you want to ignore.
966 # The default is to ignore no matches.
967 ignore_doubled_word_match_RE_ ?= ^$$
968
969 sc_prohibit_doubled_word:
970         @perl -n -0777 $(prohibit_doubled_word_) $$($(VC_LIST_EXCEPT))  \
971           | grep -vE '$(ignore_doubled_word_match_RE_)'                 \
972           | grep . && { echo '$(ME): doubled words' 1>&2; exit 1; } || :
973
974 # A regular expression matching undesirable combinations of words like
975 # "can not"; this matches them even when the two words appear on different
976 # lines, but not when there is an intervening delimiter like "#" or "*".
977 # Similarly undesirable, "See @xref{...}", since an @xref should start
978 # a sentence.  Explicitly prohibit any prefix of "see" or "also".
979 # Also prohibit a prefix matching "\w+ +".
980 # @pxref gets the same see/also treatment and should be parenthesized;
981 # presume it must *not* start a sentence.
982 bad_xref_re_ ?= (?:[\w,:;] +|(?:see|also)\s+)\@xref\{
983 bad_pxref_re_ ?= (?:[.!?]|(?:see|also))\s+\@pxref\{
984 prohibit_undesirable_word_seq_RE_ ?=                                    \
985   /(?:\bcan\s+not\b|$(bad_xref_re_)|$(bad_pxref_re_))/gims
986 prohibit_undesirable_word_seq_ =                                        \
987     -e 'while ($(prohibit_undesirable_word_seq_RE_))'                   \
988     $(perl_filename_lineno_text_)
989 # Define this to a regular expression that matches
990 # any filename:dd:match lines you want to ignore.
991 # The default is to ignore no matches.
992 ignore_undesirable_word_sequence_RE_ ?= ^$$
993
994 sc_prohibit_undesirable_word_seq:
995         @perl -n -0777 $(prohibit_undesirable_word_seq_)                \
996              $$($(VC_LIST_EXCEPT))                                      \
997           | grep -vE '$(ignore_undesirable_word_sequence_RE_)' | grep . \
998           && { echo '$(ME): undesirable word sequence' >&2; exit 1; } || :
999
1000 _ptm1 = use "test C1 && test C2", not "test C1 -''a C2"
1001 _ptm2 = use "test C1 || test C2", not "test C1 -''o C2"
1002 # Using test's -a and -o operators is not portable.
1003 # We prefer test over [, since the latter is spelled [[ in configure.ac.
1004 sc_prohibit_test_minus_ao:
1005         @prohibit='(\<test| \[+) .+ -[ao] '                             \
1006         halt='$(_ptm1); $(_ptm2)'                                       \
1007           $(_sc_search_regexp)
1008
1009 # Avoid a test bashism.
1010 sc_prohibit_test_double_equal:
1011         @prohibit='(\<test| \[+) .+ == '                                \
1012         containing='#! */bin/[a-z]*sh'                                  \
1013         halt='use "test x = x", not "test x =''= x"'                    \
1014           $(_sc_search_regexp)
1015
1016 # Each program that uses proper_name_utf8 must link with one of the
1017 # ICONV libraries.  Otherwise, some ICONV library must appear in LDADD.
1018 # The perl -0777 invocation below extracts the possibly-multi-line
1019 # definition of LDADD from the appropriate Makefile.am and exits 0
1020 # when it contains "ICONV".
1021 sc_proper_name_utf8_requires_ICONV:
1022         @progs=$$(grep -l 'proper_name_utf8 ''("' $$($(VC_LIST_EXCEPT)));\
1023         if test "x$$progs" != x; then                                   \
1024           fail=0;                                                       \
1025           for p in $$progs; do                                          \
1026             dir=$$(dirname "$$p");                                      \
1027             perl -0777                                                  \
1028               -ne 'exit !(/^LDADD =(.+?[^\\]\n)/ms && $$1 =~ /ICONV/)'  \
1029               $$dir/Makefile.am && continue;                            \
1030             base=$$(basename "$$p" .c);                                 \
1031             grep "$${base}_LDADD.*ICONV)" $$dir/Makefile.am > /dev/null \
1032               || { fail=1; echo 1>&2 "$(ME): $$p uses proper_name_utf8"; }; \
1033           done;                                                         \
1034           test $$fail = 1 &&                                            \
1035             { echo 1>&2 '$(ME): the above do not link with any ICONV library'; \
1036               exit 1; } || :;                                           \
1037         fi
1038
1039 # Warn about "c0nst struct Foo const foo[]",
1040 # but not about "char const *const foo" or "#define const const".
1041 sc_redundant_const:
1042         @prohibit='\bconst\b[[:space:][:alnum:]]{2,}\bconst\b'          \
1043         halt='redundant "const" in declarations'                        \
1044           $(_sc_search_regexp)
1045
1046 sc_const_long_option:
1047         @prohibit='^ *static.*struct option '                           \
1048         exclude='const struct option|struct option const'               \
1049         halt='add "const" to the above declarations'                    \
1050           $(_sc_search_regexp)
1051
1052 NEWS_hash =                                                             \
1053   $$(sed -n '/^\*.* $(PREV_VERSION_REGEXP) ([0-9-]*)/,$$p'              \
1054        $(srcdir)/NEWS                                                   \
1055      | perl -0777 -pe                                                   \
1056         's/^Copyright.+?Free\sSoftware\sFoundation,\sInc\.\n//ms'       \
1057      | md5sum -                                                         \
1058      | sed 's/ .*//')
1059
1060 # Ensure that we don't accidentally insert an entry into an old NEWS block.
1061 sc_immutable_NEWS:
1062         @if test -f $(srcdir)/NEWS; then                                \
1063           test "$(NEWS_hash)" = '$(old_NEWS_hash)' && : ||              \
1064             { echo '$(ME): you have modified old NEWS' 1>&2; exit 1; }; \
1065         fi
1066
1067 # Update the hash stored above.  Do this after each release and
1068 # for any corrections to old entries.
1069 update-NEWS-hash: NEWS
1070         perl -pi -e 's/^(old_NEWS_hash[ \t]+:?=[ \t]+).*/$${1}'"$(NEWS_hash)/" \
1071           $(srcdir)/cfg.mk
1072
1073 # Ensure that we use only the standard $(VAR) notation,
1074 # not @...@ in Makefile.am, now that we can rely on automake
1075 # to emit a definition for each substituted variable.
1076 # However, there is still one case in which @VAR@ use is not just
1077 # legitimate, but actually required: when augmenting an automake-defined
1078 # variable with a prefix.  For example, gettext uses this:
1079 # MAKEINFO = env LANG= LC_MESSAGES= LC_ALL= LANGUAGE= @MAKEINFO@
1080 # otherwise, makeinfo would put German or French (current locale)
1081 # navigation hints in the otherwise-English documentation.
1082 #
1083 # Allow the package to add exceptions via a hook in cfg.mk;
1084 # for example, @PRAGMA_SYSTEM_HEADER@ can be permitted by
1085 # setting this to ' && !/PRAGMA_SYSTEM_HEADER/'.
1086 _makefile_at_at_check_exceptions ?=
1087 sc_makefile_at_at_check:
1088         @perl -ne '/\@\w+\@/'                                           \
1089           -e ' && !/(\w+)\s+=.*\@\1\@$$/'                               \
1090           -e ''$(_makefile_at_at_check_exceptions)                      \
1091           -e 'and (print "$$ARGV:$$.: $$_"), $$m=1; END {exit !$$m}'    \
1092             $$($(VC_LIST_EXCEPT) | grep -E '(^|/)(Makefile\.am|[^/]+\.mk)$$') \
1093           && { echo '$(ME): use $$(...), not @...@' 1>&2; exit 1; } || :
1094
1095 news-check: NEWS
1096         $(AM_V_GEN)if sed -n $(news-check-lines-spec)p $<               \
1097             | grep -E $(news-check-regexp) >/dev/null; then             \
1098           :;                                                            \
1099         else                                                            \
1100           echo 'NEWS: $$(news-check-regexp) failed to match' 1>&2;      \
1101           exit 1;                                                       \
1102         fi
1103
1104 sc_makefile_TAB_only_indentation:
1105         @prohibit='^    [ ]{8}'                                         \
1106         in_vc_files='akefile|\.mk$$'                                    \
1107         halt='found TAB-8-space indentation'                            \
1108           $(_sc_search_regexp)
1109
1110 sc_m4_quote_check:
1111         @prohibit='(AC_DEFINE(_UNQUOTED)?|AC_DEFUN)\([^[]'              \
1112         in_vc_files='(^configure\.ac|\.m4)$$'                           \
1113         halt='quote the first arg to AC_DEF*'                           \
1114           $(_sc_search_regexp)
1115
1116 fix_po_file_diag = \
1117 'you have changed the set of files with translatable diagnostics;\n\
1118 apply the above patch\n'
1119
1120 # Verify that all source files using _() are listed in po/POTFILES.in.
1121 po_file ?= $(srcdir)/po/POTFILES.in
1122 generated_files ?= $(srcdir)/lib/*.[ch]
1123 sc_po_check:
1124         @if test -f $(po_file); then                                    \
1125           grep -E -v '^(#|$$)' $(po_file)                               \
1126             | grep -v '^src/false\.c$$' | sort > $@-1;                  \
1127           files=;                                                       \
1128           for file in $$($(VC_LIST_EXCEPT)) $(generated_files); do      \
1129             test -r $$file || continue;                                 \
1130             case $$file in                                              \
1131               *.m4|*.mk) continue ;;                                    \
1132               *.?|*.??) ;;                                              \
1133               *) continue;;                                             \
1134             esac;                                                       \
1135             case $$file in                                              \
1136             *.[ch])                                                     \
1137               base=`expr " $$file" : ' \(.*\)\..'`;                     \
1138               { test -f $$base.l || test -f $$base.y; } && continue;;   \
1139             esac;                                                       \
1140             files="$$files $$file";                                     \
1141           done;                                                         \
1142           grep -E -l '\b(N?_|gettext *)\([^)"]*("|$$)' $$files          \
1143             | sed 's|^$(_dot_escaped_srcdir)/||' | sort -u > $@-2;      \
1144           diff -u -L $(po_file) -L $(po_file) $@-1 $@-2                 \
1145             || { printf '$(ME): '$(fix_po_file_diag) 1>&2; exit 1; };   \
1146           rm -f $@-1 $@-2;                                              \
1147         fi
1148
1149 # Sometimes it is useful to change the PATH environment variable
1150 # in Makefiles.  When doing so, it's better not to use the Unix-centric
1151 # path separator of ':', but rather the automake-provided '$(PATH_SEPARATOR)'.
1152 msg = 'Do not use ":" above; use $$(PATH_SEPARATOR) instead'
1153 sc_makefile_path_separator_check:
1154         @prohibit='PATH[=].*:'                                          \
1155         in_vc_files='akefile|\.mk$$'                                    \
1156         halt=$(msg)                                                     \
1157           $(_sc_search_regexp)
1158
1159 # Check that 'make alpha' will not fail at the end of the process,
1160 # i.e., when pkg-M.N.tar.xz already exists (either in "." or in ../release)
1161 # and is read-only.
1162 writable-files:
1163         $(AM_V_GEN)if test -d $(release_archive_dir); then              \
1164           for file in $(DIST_ARCHIVES); do                              \
1165             for p in ./ $(release_archive_dir)/; do                     \
1166               test -e $$p$$file || continue;                            \
1167               test -w $$p$$file                                         \
1168                 || { echo ERROR: $$p$$file is not writable; fail=1; };  \
1169             done;                                                       \
1170           done;                                                         \
1171           test "$$fail" && exit 1 || : ;                                \
1172         else :;                                                         \
1173         fi
1174
1175 v_etc_file = $(gnulib_dir)/lib/version-etc.c
1176 sample-test = tests/sample-test
1177 texi = doc/$(PACKAGE).texi
1178 # Make sure that the copyright date in $(v_etc_file) is up to date.
1179 # Do the same for the $(sample-test) and the main doc/.texi file.
1180 sc_copyright_check:
1181         @require='enum { COPYRIGHT_YEAR = '$$(date +%Y)' };'            \
1182         in_files=$(v_etc_file)                                          \
1183         halt='out of date copyright in $(v_etc_file); update it'        \
1184           $(_sc_search_regexp)
1185         @require='# Copyright \(C\) '$$(date +%Y)' Free'                \
1186         in_vc_files=$(sample-test)                                      \
1187         halt='out of date copyright in $(sample-test); update it'       \
1188           $(_sc_search_regexp)
1189         @require='Copyright @copyright\{\} .*'$$(date +%Y)' Free'       \
1190         in_vc_files=$(texi)                                             \
1191         halt='out of date copyright in $(texi); update it'              \
1192           $(_sc_search_regexp)
1193
1194 # If tests/help-version exists and seems to be new enough, assume that its
1195 # use of init.sh and path_prepend_ is correct, and ensure that every other
1196 # use of init.sh is identical.
1197 # This is useful because help-version cross-checks prog --version
1198 # with $(VERSION), which verifies that its path_prepend_ invocation
1199 # sets PATH correctly.  This is an inexpensive way to ensure that
1200 # the other init.sh-using tests also get it right.
1201 _hv_file ?= $(srcdir)/tests/help-version
1202 _hv_regex_weak ?= ^ *\. .*/init\.sh"
1203 # Fix syntax-highlighters "
1204 _hv_regex_strong ?= ^ *\. "\$${srcdir=\.}/init\.sh"
1205 sc_cross_check_PATH_usage_in_tests:
1206         @if test -f $(_hv_file); then                                   \
1207           grep -l 'VERSION mismatch' $(_hv_file) >/dev/null             \
1208             || { echo "$@: skipped: no such file: $(_hv_file)" 1>&2;    \
1209                  exit 0; };                                             \
1210           grep -lE '$(_hv_regex_strong)' $(_hv_file) >/dev/null         \
1211             || { echo "$@: $(_hv_file) lacks conforming use of init.sh" 1>&2; \
1212                  exit 1; };                                             \
1213           good=$$(grep -E '$(_hv_regex_strong)' $(_hv_file));           \
1214           grep -LFx "$$good"                                            \
1215                 $$(grep -lE '$(_hv_regex_weak)' $$($(VC_LIST_EXCEPT)))  \
1216               | grep . &&                                               \
1217             { echo "$(ME): the above files use path_prepend_ inconsistently" \
1218                 1>&2; exit 1; } || :;                                   \
1219         fi
1220
1221 # BRE regex of file contents to identify a test script.
1222 _test_script_regex ?= \<init\.sh\>
1223
1224 # In tests, use "compare expected actual", not the reverse.
1225 sc_prohibit_reversed_compare_failure:
1226         @prohibit='\<compare [^ ]+ ([^ ]*exp|/dev/null)'                \
1227         containing='$(_test_script_regex)'                              \
1228         halt='reversed compare arguments'                               \
1229           $(_sc_search_regexp)
1230
1231 # #if HAVE_... will evaluate to false for any non numeric string.
1232 # That would be flagged by using -Wundef, however gnulib currently
1233 # tests many undefined macros, and so we can't enable that option.
1234 # So at least preclude common boolean strings as macro values.
1235 sc_Wundef_boolean:
1236         @prohibit='^#define.*(yes|no|true|false)$$'                     \
1237         in_files='$(CONFIG_INCLUDE)'                                    \
1238         halt='Use 0 or 1 for macro values'                              \
1239           $(_sc_search_regexp)
1240
1241 # Even if you use pathmax.h to guarantee that PATH_MAX is defined, it might
1242 # not be constant, or might overflow a stack.  In general, use PATH_MAX as
1243 # a limit, not an array or alloca size.
1244 sc_prohibit_path_max_allocation:
1245         @prohibit='(\balloca *\([^)]*|\[[^]]*)\bPATH_MAX'               \
1246         halt='Avoid stack allocations of size PATH_MAX'                 \
1247           $(_sc_search_regexp)
1248
1249 sc_vulnerable_makefile_CVE-2009-4029:
1250         @prohibit='perm -777 -exec chmod a\+rwx|chmod 777 \$$\(distdir\)' \
1251         in_files='(^|/)Makefile\.in$$'                                  \
1252         halt=$$(printf '%s\n'                                           \
1253           'the above files are vulnerable; beware of running'           \
1254           '  "make dist*" rules, and upgrade to fixed automake'         \
1255           '  see http://bugzilla.redhat.com/542609 for details')        \
1256           $(_sc_search_regexp)
1257
1258 sc_vulnerable_makefile_CVE-2012-3386:
1259         @prohibit='chmod a\+w \$$\(distdir\)'                           \
1260         in_files='(^|/)Makefile\.in$$'                                  \
1261         halt=$$(printf '%s\n'                                           \
1262           'the above files are vulnerable; beware of running'           \
1263           '  "make distcheck", and upgrade to fixed automake'           \
1264           '  see http://bugzilla.redhat.com/CVE-2012-3386 for details') \
1265           $(_sc_search_regexp)
1266
1267 vc-diff-check:
1268         $(AM_V_GEN)(unset CDPATH; cd $(srcdir) && $(VC) diff) > vc-diffs || :
1269         $(AM_V_at)if test -s vc-diffs; then                     \
1270           cat vc-diffs;                                         \
1271           echo "Some files are locally modified:" 1>&2;         \
1272           exit 1;                                               \
1273         else                                                    \
1274           rm vc-diffs;                                          \
1275         fi
1276
1277 rel-files = $(DIST_ARCHIVES)
1278
1279 gnulib_dir ?= $(srcdir)/gnulib
1280 gnulib-version = $$(cd $(gnulib_dir) && git describe)
1281 bootstrap-tools ?= autoconf,automake,gnulib
1282
1283 # If it's not already specified, derive the GPG key ID from
1284 # the signed tag we've just applied to mark this release.
1285 gpg_key_ID ?=                                                           \
1286   $$(cd $(srcdir)                                                       \
1287      && git cat-file tag v$(VERSION)                                    \
1288         | gpgv --status-fd 1 --keyring /dev/null - - 2>/dev/null        \
1289         | awk '/^\[GNUPG:\] ERRSIG / {print $$3; exit}')
1290
1291 translation_project_ ?= coordinator@translationproject.org
1292
1293 # Make info-gnu the default only for a stable release.
1294 ifeq ($(release-type),stable)
1295   announcement_Cc_ ?= $(translation_project_), $(PACKAGE_BUGREPORT)
1296   announcement_mail_headers_ ?=                                         \
1297     To: info-gnu@gnu.org                                                \
1298     Cc: $(announcement_Cc_)                                             \
1299     Mail-Followup-To: $(PACKAGE_BUGREPORT)
1300 else
1301   announcement_Cc_ ?= $(translation_project_)
1302   announcement_mail_headers_ ?=                                         \
1303     To: $(PACKAGE_BUGREPORT)                                            \
1304     Cc: $(announcement_Cc_)
1305 endif
1306
1307 announcement: NEWS ChangeLog $(rel-files)
1308 # Not $(AM_V_GEN) since the output of this command serves as
1309 # annoucement message: it would start with " GEN announcement".
1310         $(AM_V_at)$(srcdir)/$(_build-aux)/announce-gen                  \
1311             --mail-headers='$(announcement_mail_headers_)'              \
1312             --release-type=$(release-type)                              \
1313             --package=$(PACKAGE)                                        \
1314             --prev=$(PREV_VERSION)                                      \
1315             --curr=$(VERSION)                                           \
1316             --gpg-key-id=$(gpg_key_ID)                                  \
1317             --srcdir=$(srcdir)                                          \
1318             --news=$(srcdir)/NEWS                                       \
1319             --bootstrap-tools=$(bootstrap-tools)                        \
1320             $$(case ,$(bootstrap-tools), in (*,gnulib,*)                \
1321                echo --gnulib-version=$(gnulib-version);; esac)          \
1322             --no-print-checksums                                        \
1323             $(addprefix --url-dir=, $(url_dir_list))
1324
1325 .PHONY: release-commit
1326 release-commit:
1327         $(AM_V_GEN)cd $(srcdir)                         \
1328           && $(_build-aux)/do-release-commit-and-tag    \
1329                -C $(abs_builddir) $(RELEASE)
1330
1331 ## ---------------- ##
1332 ## Updating files.  ##
1333 ## ---------------- ##
1334
1335 ftp-gnu = ftp://ftp.gnu.org/gnu
1336 www-gnu = http://www.gnu.org
1337
1338 upload_dest_dir_ ?= $(PACKAGE)
1339 upload_command =                                                \
1340   $(srcdir)/$(_build-aux)/gnupload $(GNUPLOADFLAGS)             \
1341   --to $(gnu_rel_host):$(upload_dest_dir_)                      \
1342   $(rel-files)
1343 emit_upload_commands:
1344         @echo =====================================
1345         @echo =====================================
1346         @echo '$(upload_command)'
1347         @echo '# send the ~/announce-$(my_distdir) e-mail'
1348         @echo =====================================
1349         @echo =====================================
1350
1351 .PHONY: upload
1352 upload:
1353         $(AM_V_GEN)$(upload_command)
1354
1355 define emit-commit-log
1356   printf '%s\n' 'maint: post-release administrivia' ''                  \
1357     '* NEWS: Add header line for next release.'                         \
1358     '* .prev-version: Record previous version.'                         \
1359     '* cfg.mk (old_NEWS_hash): Auto-update.'
1360 endef
1361
1362 .PHONY: no-submodule-changes
1363 no-submodule-changes:
1364         $(AM_V_GEN)if test -d $(srcdir)/.git; then                      \
1365           diff=$$(cd $(srcdir) && git submodule -q foreach              \
1366                   git diff-index --name-only HEAD)                      \
1367             || exit 1;                                                  \
1368           case $$diff in '') ;;                                         \
1369             *) echo '$(ME): submodule files are locally modified:';     \
1370                 echo "$$diff"; exit 1;; esac;                           \
1371         else                                                            \
1372           : ;                                                           \
1373         fi
1374
1375 submodule-checks ?= no-submodule-changes public-submodule-commit
1376
1377 # Ensure that each sub-module commit we're using is public.
1378 # Without this, it is too easy to tag and release code that
1379 # cannot be built from a fresh clone.
1380 .PHONY: public-submodule-commit
1381 public-submodule-commit:
1382         $(AM_V_GEN)if test -d $(srcdir)/.git; then                      \
1383           cd $(srcdir) &&                                               \
1384           git submodule --quiet foreach test '$$(git rev-parse $$sha1)' \
1385               = '$$(git merge-base origin $$sha1)'                      \
1386             || { echo '$(ME): found non-public submodule commit' >&2;   \
1387                  exit 1; };                                             \
1388         else                                                            \
1389           : ;                                                           \
1390         fi
1391 # This rule has a high enough utility/cost ratio that it should be a
1392 # dependent of "check" by default.  However, some of us do occasionally
1393 # commit a temporary change that deliberately points to a non-public
1394 # submodule commit, and want to be able to use rules like "make check".
1395 # In that case, run e.g., "make check gl_public_submodule_commit="
1396 # to disable this test.
1397 gl_public_submodule_commit ?= public-submodule-commit
1398 check: $(gl_public_submodule_commit)
1399
1400 .PHONY: alpha beta stable release
1401 ALL_RECURSIVE_TARGETS += alpha beta stable
1402 alpha beta stable: $(local-check) writable-files $(submodule-checks)
1403         $(AM_V_GEN)test $@ = stable                                     \
1404           && { echo $(VERSION) | grep -E '^[0-9]+(\.[0-9]+)+$$'         \
1405                || { echo "invalid version string: $(VERSION)" 1>&2; exit 1;};}\
1406           || :
1407         $(AM_V_at)$(MAKE) vc-diff-check
1408         $(AM_V_at)$(MAKE) news-check
1409         $(AM_V_at)$(MAKE) distcheck
1410         $(AM_V_at)$(MAKE) dist
1411         $(AM_V_at)$(MAKE) $(release-prep-hook) RELEASE_TYPE=$@
1412         $(AM_V_at)$(MAKE) -s emit_upload_commands RELEASE_TYPE=$@
1413
1414 release: $(release-type)
1415
1416 # Override this in cfg.mk if you follow different procedures.
1417 release-prep-hook ?= release-prep
1418
1419 gl_noteworthy_news_ = * Noteworthy changes in release ?.? (????-??-??) [?]
1420 .PHONY: release-prep
1421 release-prep:
1422         $(AM_V_GEN)$(MAKE) --no-print-directory -s announcement \
1423           > ~/announce-$(my_distdir)
1424         $(AM_V_at)if test -d $(release_archive_dir); then       \
1425           ln $(rel-files) $(release_archive_dir);               \
1426           chmod a-w $(rel-files);                               \
1427         fi
1428         $(AM_V_at)echo $(VERSION) > $(prev_version_file)
1429         $(AM_V_at)$(MAKE) update-NEWS-hash
1430         $(AM_V_at)perl -pi                                              \
1431           -e '$$. == 3 and print "$(gl_noteworthy_news_)\n\n\n"'        \
1432           $(srcdir)/NEWS
1433         $(AM_V_at)msg=$$($(emit-commit-log)) || exit 1;         \
1434         cd $(srcdir) && $(VC) commit -m "$$msg" -a
1435
1436 # Override this with e.g., -s $(srcdir)/some_other_name.texi
1437 # if the default $(PACKAGE)-derived name doesn't apply.
1438 gendocs_options_ ?=
1439
1440 .PHONY: web-manual
1441 web-manual:
1442         $(AM_V_GEN)test -z "$(manual_title)" \
1443           && { echo define manual_title in cfg.mk 1>&2; exit 1; } || :
1444         $(AM_V_at)cd '$(srcdir)/doc'; \
1445           $(SHELL) ../$(_build-aux)/gendocs.sh $(gendocs_options_) \
1446              -o '$(abs_builddir)/doc/manual' \
1447              --email $(PACKAGE_BUGREPORT) $(PACKAGE) \
1448             "$(PACKAGE_NAME) - $(manual_title)"
1449         $(AM_V_at)echo " *** Upload the doc/manual directory to web-cvs."
1450
1451 .PHONY: web-manual-update
1452 web-manual-update:
1453         $(AM_V_GEN)cd $(srcdir) \
1454           && $(_build-aux)/gnu-web-doc-update -C $(abs_builddir)
1455
1456
1457 # Code Coverage
1458
1459 init-coverage:
1460         $(MAKE) $(AM_MAKEFLAGS) clean
1461         lcov --directory . --zerocounters
1462
1463 COVERAGE_CCOPTS ?= "-g --coverage"
1464 COVERAGE_OUT ?= doc/coverage
1465
1466 build-coverage:
1467         $(MAKE) $(AM_MAKEFLAGS) CFLAGS=$(COVERAGE_CCOPTS) CXXFLAGS=$(COVERAGE_CCOPTS)
1468         $(MAKE) $(AM_MAKEFLAGS) CFLAGS=$(COVERAGE_CCOPTS) CXXFLAGS=$(COVERAGE_CCOPTS) check
1469         mkdir -p $(COVERAGE_OUT)
1470         lcov --directory . --output-file $(COVERAGE_OUT)/$(PACKAGE).info \
1471                 --capture
1472
1473 gen-coverage:
1474         genhtml --output-directory $(COVERAGE_OUT) \
1475                 $(COVERAGE_OUT)/$(PACKAGE).info \
1476                 --highlight --frames --legend \
1477                 --title "$(PACKAGE_NAME)"
1478
1479 coverage: init-coverage build-coverage gen-coverage
1480
1481 # Some projects carry local adjustments for gnulib modules via patches in
1482 # a gnulib patch directory whose default name is gl/ (defined in bootstrap
1483 # via local_gl_dir=gl).  Those patches become stale as the originals evolve
1484 # in gnulib.  Use this rule to refresh any stale patches.  It applies each
1485 # patch to the original in $(gnulib_dir) and uses the temporary result to
1486 # generate a fuzz-free .diff file.  If you customize the name of your local
1487 # gnulib patch directory via bootstrap.conf, this rule detects that name.
1488 # Run this from a non-VPATH (i.e., srcdir) build directory.
1489 .PHONY: refresh-gnulib-patches
1490 refresh-gnulib-patches:
1491         gl=gl;                                                          \
1492         if test -f bootstrap.conf; then                                 \
1493           t=$$(perl -lne '/^\s*local_gl_dir=(\S+)/ and $$d=$$1;'        \
1494                -e 'END{defined $$d and print $$d}' bootstrap.conf);     \
1495           test -n "$$t" && gl=$$t;                                      \
1496         fi;                                                             \
1497         for diff in $$(cd $$gl; git ls-files | grep '\.diff$$'); do     \
1498           b=$$(printf %s "$$diff"|sed 's/\.diff$$//');                  \
1499           VERSION_CONTROL=none                                          \
1500             patch "$(gnulib_dir)/$$b" "$$gl/$$diff" || exit 1;          \
1501           ( cd $(gnulib_dir) || exit 1;                                 \
1502             git diff "$$b" > "../$$gl/$$diff";                          \
1503             git checkout $$b ) || exit 1;                               \
1504         done
1505
1506 # Update gettext files.
1507 PACKAGE ?= $(shell basename $(PWD))
1508 PO_DOMAIN ?= $(PACKAGE)
1509 POURL = http://translationproject.org/latest/$(PO_DOMAIN)/
1510 PODIR ?= po
1511 refresh-po:
1512         rm -f $(PODIR)/*.po && \
1513         echo "$(ME): getting translations into po (please ignore the robots.txt ERROR 404)..." && \
1514         wget --no-verbose --directory-prefix $(PODIR) --no-directories --recursive --level 1 --accept .po --accept .po.1 $(POURL) && \
1515         echo 'en@boldquot' > $(PODIR)/LINGUAS && \
1516         echo 'en@quot' >> $(PODIR)/LINGUAS && \
1517         ls $(PODIR)/*.po | sed 's/\.po//;s,$(PODIR)/,,' | sort >> $(PODIR)/LINGUAS
1518
1519  # Running indent once is not idempotent, but running it twice is.
1520 INDENT_SOURCES ?= $(C_SOURCES)
1521 .PHONY: indent
1522 indent:
1523         indent $(INDENT_SOURCES)
1524         indent $(INDENT_SOURCES)
1525
1526 # If you want to set UPDATE_COPYRIGHT_* environment variables,
1527 # put the assignments in this variable.
1528 update-copyright-env ?=
1529
1530 # Run this rule once per year (usually early in January)
1531 # to update all FSF copyright year lists in your project.
1532 # If you have an additional project-specific rule,
1533 # add it in cfg.mk along with a line 'update-copyright: prereq'.
1534 # By default, exclude all variants of COPYING; you can also
1535 # add exemptions (such as ChangeLog..* for rotated change logs)
1536 # in the file .x-update-copyright.
1537 .PHONY: update-copyright
1538 update-copyright:
1539         $(AM_V_GEN)grep -l -w Copyright                                  \
1540           $$(export VC_LIST_EXCEPT_DEFAULT=COPYING && $(VC_LIST_EXCEPT)) \
1541           | $(update-copyright-env) xargs $(srcdir)/$(_build-aux)/$@
1542
1543 # This tight_scope test is skipped with a warning if $(_gl_TS_headers) is not
1544 # overridden and $(_gl_TS_dir)/Makefile.am does not mention noinst_HEADERS.
1545
1546 # NOTE: to override any _gl_TS_* default value, you must
1547 # define the variable(s) using "export" in cfg.mk.
1548 _gl_TS_dir ?= src
1549
1550 ALL_RECURSIVE_TARGETS += sc_tight_scope
1551 sc_tight_scope: tight-scope.mk
1552         @fail=0;                                                        \
1553         if ! grep '^ *export _gl_TS_headers *=' $(srcdir)/cfg.mk        \
1554                 > /dev/null                                             \
1555            && ! grep -w noinst_HEADERS $(srcdir)/$(_gl_TS_dir)/Makefile.am \
1556                 > /dev/null 2>&1; then                                  \
1557             echo '$(ME): skipping $@';                                  \
1558         else                                                            \
1559             $(MAKE) -s -C $(_gl_TS_dir)                                 \
1560                 -f Makefile                                             \
1561                 -f $(abs_top_srcdir)/cfg.mk                             \
1562                 -f $(abs_top_builddir)/$<                               \
1563               _gl_tight_scope                                           \
1564                 || fail=1;                                              \
1565         fi;                                                             \
1566         rm -f $<;                                                       \
1567         exit $$fail
1568
1569 tight-scope.mk: $(ME)
1570         @rm -f $@ $@-t
1571         @perl -ne '/^# TS-start/.../^# TS-end/ and print' $(srcdir)/$(ME) > $@-t
1572         @chmod a=r $@-t && mv $@-t $@
1573
1574 ifeq (a,b)
1575 # TS-start
1576
1577 # Most functions should have static scope.
1578 # Any that don't must be marked with 'extern', but 'main'
1579 # and 'usage' are exceptions: they're always extern, but
1580 # do not need to be marked.  Symbols matching '__.*' are
1581 # reserved by the compiler, so are automatically excluded below.
1582 _gl_TS_unmarked_extern_functions ?= main usage
1583 _gl_TS_function_match ?= /^(?:$(_gl_TS_extern)) +.*?(\S+) *\(/
1584
1585 # If your project uses a macro like "XTERN", then put
1586 # the following in cfg.mk to override this default:
1587 # export _gl_TS_extern = extern|XTERN
1588 _gl_TS_extern ?= extern
1589
1590 # The second nm|grep checks for file-scope variables with 'extern' scope.
1591 # Without gnulib's progname module, you might put program_name here.
1592 # Symbols matching '__.*' are reserved by the compiler,
1593 # so are automatically excluded below.
1594 _gl_TS_unmarked_extern_vars ?=
1595
1596 # NOTE: the _match variables are perl expressions -- not mere regular
1597 # expressions -- so that you can extend them to match other patterns
1598 # and easily extract matched variable names.
1599 # For example, if your project declares some global variables via
1600 # a macro like this: GLOBAL(type, var_name, initializer), then you
1601 # can override this definition to automatically extract those names:
1602 # export _gl_TS_var_match = \
1603 #   /^(?:$(_gl_TS_extern)) .*?\**(\w+)(\[.*?\])?;/ || /\bGLOBAL\(.*?,\s*(.*?),/
1604 _gl_TS_var_match ?= /^(?:$(_gl_TS_extern)) .*?(\w+)(\[.*?\])?;/
1605
1606 # The names of object files in (or relative to) $(_gl_TS_dir).
1607 _gl_TS_obj_files ?= *.$(OBJEXT)
1608
1609 # Files in which to search for the one-line style extern declarations.
1610 # $(_gl_TS_dir)-relative.
1611 _gl_TS_headers ?= $(noinst_HEADERS)
1612 _gl_TS_other_headers ?= *.h
1613
1614 .PHONY: _gl_tight_scope
1615 _gl_tight_scope: $(bin_PROGRAMS)
1616         t=exceptions-$$$$;                                              \
1617         trap 's=$$?; rm -f $$t; exit $$s' 0;                            \
1618         for sig in 1 2 3 13 15; do                                      \
1619           eval "trap 'v=`expr $$sig + 128`; (exit $$v); exit $$v' $$sig"; \
1620         done;                                                           \
1621         src=`for f in $(SOURCES); do                                    \
1622                test -f $$f && d= || d=$(srcdir)/; echo $$d$$f; done`;   \
1623         hdr=`for f in $(_gl_TS_headers); do                             \
1624                test -f $$f && d= || d=$(srcdir)/; echo $$d$$f; done`;   \
1625         ( printf '^%s$$\n' '__.*' $(_gl_TS_unmarked_extern_functions);  \
1626           grep -h -A1 '^extern .*[^;]$$' $$src                          \
1627             | grep -vE '^(extern |--)' | sed 's/ .*//';                 \
1628           perl -lne                                                     \
1629              '$(_gl_TS_function_match) and print "^$$1\$$"' $$hdr;      \
1630         ) | sort -u > $$t;                                              \
1631         nm -e $(_gl_TS_obj_files) | sed -n 's/.* T //p'|grep -Ev -f $$t \
1632           && { echo the above functions should have static scope >&2;   \
1633                exit 1; } || : ;                                         \
1634         ( printf '^%s$$\n' '__.*' $(_gl_TS_unmarked_extern_vars);       \
1635           perl -lne '$(_gl_TS_var_match) and print "^$$1\$$"'           \
1636                 $$hdr $(_gl_TS_other_headers)                           \
1637         ) | sort -u > $$t;                                              \
1638         nm -e $(_gl_TS_obj_files) | sed -n 's/.* [BCDGRS] //p'          \
1639             | sort -u | grep -Ev -f $$t                                 \
1640           && { echo the above variables should have static scope >&2;   \
1641                exit 1; } || :
1642 # TS-end
1643 endif